unit cplx;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils;

type
  komplex = object
    Fre, Fim: real;
    constructor Init(_re, _im: double);
    property Re: double read Fre write Fre;
    property Im: double read Fim write Fim;
  end;

operator +(z: komplex): komplex;
operator -(z: komplex): komplex;

operator +(z, w: komplex): komplex;
//operator +(z: komplex; w: real): komplex;   // Lze, ale uděláme jinak

operator :=(x: real): komplex;

operator =(z, w: komplex) vysl: Boolean;


implementation

constructor komplex.Init(_re, _im: double);
begin
  Re := _re;
  Im := _im;
end;

operator +(z: komplex): komplex;
begin
  Result := z;
end;

operator -(z: komplex): komplex;
begin
  Result.Re := -z.Re;
  Result.Im := -z.Im;
end;

operator +(z, w: komplex): komplex;
begin
   Result.Re := z.Re + w.Re;
   Result.Im := z.Im + w.Im;
end;

{operator +(z: komplex; w: real): komplex;
begin
   Result.Re := z.Re + w;
   Result.Im := z.Im;
end;    }

operator :=(x: real): komplex;
begin
   Result.Re := x;
   Result.Im := 0;
end;

operator =(z, w: komplex) vysl: Boolean;
begin
   vysl := (z.Re = w.Re) and (z.Im = w.Im);
end;

end.

