program SeznamProg;

type
  generic TPrvek<T> = class
    private
      FData: T;
      FDalsi: TPrvek;
    public
      constructor Create(_data: T; _dalsi: TPrvek);
      constructor Create;
      property Data: T read FData write FData;
      property Dalsi: TPrvek read FDalsi write FDalsi;
  end;

constructor TPrvek.Create(_data: T; _dalsi: TPrvek);
begin
   FData:= _data;
   FDalsi:=_dalsi;
end;

constructor TPrvek.Create;
begin
   FDalsi := nil;
end;

type
  generic TSeznam<T> = class
    private
      type
        Prvek = specialize TPrvek<T>;
      var
        FHlava, FZarazka: Prvek;
        FAktual: Prvek;
      function getAktualniData: T;
      procedure setAktualniData(_data: T);
    public
      constructor Create;
      destructor Destroy; override;
      procedure vlozNaZacatek(co: T);

      procedure vypis;                  // Jen je-li T vestavěný typ
  end;

constructor TSeznam.Create;
begin
   FHlava := Prvek.Create;
   FZarazka:=FHlava;
   FAktual:=FHlava;
end;

destructor TSeznam.Destroy;
begin
   // vyprazdni;
   FHlava.Free;
end;

procedure TSeznam.vlozNaZacatek(co: T);
begin
   FHlava:= Prvek.Create(co, FHlava);
   FAktual:=FHlava;
end;

function TSeznam.getAktualniData: T;
begin
   result := FAktual.Data;
end;

procedure TSeznam.setAktualniData(_data: T);
begin
   FAktual.Data:=_data;
end;

procedure TSeznam.vypis;
var pom: Prvek;
begin
   pom := FHlava;
   while pom <> FZarazka do
   begin
     write(pom.Data, ' ');
     pom := pom.Dalsi;
   end;
   writeln;
end;

type
  seznamInt = specialize TSeznam<integer> ;

var
  seznam: seznamInt;

begin
  seznam := seznamInt.Create;
  seznam.vlozNaZacatek(1);
  seznam.vlozNaZacatek(2);
  seznam.vypis;
end.

